Story8/urls.py
from django.urls import path
from django.contrib import admin

from . import views

app_name = 'Story8'

urlpatterns = [
	path('admin/', admin.site.urls),
	path('', views.index, name='index'),
	path('login/', views.loginView, name='login'),
	path('logout/', views.logoutView, name='logout'),
	path('register/', views.registerView, name='register'),
	path('data/', views.fungsi_data),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('home', views.home, name='home'),
    path('story1', views.story1, name='story1'),
    path('experience', views.experience, name='experience'),

]

zulfandinca_story/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('story5/', include('Story5.urls')),
    path('story6/',include('Story6.urls', namespace = 'templates')),
    path('story7/', include('Story7.urls')),
    path('story8/', include('Story8.urls')),
]

Story8/models.py
from django.db import models

# Create your models here.

Story8/views.py
from django.shortcuts import render, redirect, resolve_url
from django.http import JsonResponse,HttpResponse, HttpResponseRedirect
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.models import User


import requests
import json

# Create your views here.
def index(request):
	response = {}

	return render(request, 'story8.html', response)

def loginView(request):
	response = {}
	if (not request.user.is_anonymous):
		return redirect('/story8/')

	if request.method == "POST":
		username_login = request.POST.get('username',False)
		password_login = request.POST.get('password',False)

		user = authenticate(request, username = username_login, password = password_login)

		if user is not None:
			login(request, user)
			return redirect('/story8/')
		else :
			return redirect('/story8/login/')

	return render(request, 'login.html', response)

def logoutView(request):
	logout(request)
	return redirect('/story8/')

def registerView(request):
	response = {
		'error' : False,
		'isiError' : '',
		'errorUsername' : '',
	}

	if (not request.user.is_anonymous):
		return redirect('/story8/')

	response['error']=False

	if request.method == "POST":
		name = request.POST.get('user_name_register',False)
		email = request.POST.get('user_email_register',False)
		password = request.POST.get('user_password_register',False)

		try:
			account = User.objects.get(username = name)
		except:
			account = None

		try:
			accountEmail = User.objects.get(email= email)
		except:
			accountEmail = None

		if (account == None and accountEmail == None):
			new_account = User.objects.create_user(name,email,password)
			new_account.save()
			login(request, new_account)
			return redirect('/story8/')

		elif (account!= None and accountEmail == None):
			response['error'] = True
			response['isiError'] = 'Maaf username sudah ada'
			return render(request,'register.html',response)

		elif (account== None and accountEmail != None):
			response['error'] = True
			response['isiError'] = 'Maaf email sudah ada'
			return render(request,'register.html',response)

		else:
			response['errorUsername']=True
			response['error']=True
			response['isiError']='Maaf username dan email sudah ada'
			return render(request,'register.html',response)

	return render(request,'register.html',response)


def fungsi_data(request):
	url = "https://www.googleapis.com/books/v1/volumes?q=" + request.GET['q']
	ret = requests.get(url)
	data = json.loads(ret.content)
	return JsonResponse(data, safe=False)

Story8/templates/login.html
<!DOCTYPE html>
<html>
<head>
	<title>Login</title>
</head>
<body>
	<h1>LOGIN</h1>
	<form method="POST">
		{% csrf_token %}
		<label for="username">Username:</label>
		<input type="text" name="username" id="username">
		<br>
		<label for="password">Password:</label>
		<input type="password" name="password" id="password">
		<br>
		<button type="submit">Login</button>
	</form>
</body>
</html>

Story8/templates/logout.html
<!DOCTYPE html>
<html>
<head>
	<title>Logout</title>
</head>
<body>
<h1> Log Out </h1>

<p>Apakah anda yakin untuk logout?</p>
<form method="POST">
	{% csrf_token %}
	<input type="submit" name="logout">
</form>
</body>
</html>

Story8/templates/register.html
<!DOCTYPE html>
<html>
<head>
	<title>Login</title>
</head>
<body>
	<h1>REGISTER</h1>
	<form method="POST">
		{% csrf_token %}
		<label for="user_name_register">Username:</label>
		<input type="text" name="user_name_register" id="user_name_register">
		<br>
		<label for="user_email_register">Email:</label>
		<input type="text" name="user_email_register" id="user_email_register">
		<br>
		<label for="user_password_register">Password:</label>
		<input type="password" name="user_password_register" id="user_password_register">
		<br>
		{% if error %}
		 <h3 style="color:red">{{isiError}}</h3>
		{% endif %}
		<button type="submit">Register</button>
	</form>
</body>
</html>

Story8/templates/story8.html
{% load static %}
<html>
<head>
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<style type="text/css">
		body {
                background-image: url('{% static 'img/library.jpg' %}');
                background-color: black;
            }
		table, th, td { border: 1px solid black; }

		h1 {
			color : white;
		}

	</style>
	<title>Cari Buku</title>
</head>

<body>

<nav class="navbar navbar-light bg-light">
  <form class="form-inline">
    <input id="keyword" class="form-control mr-sm-2" type="text" placeholder="Cari Buku">
  </form>
  {% if user.is_authenticated %}
	<div class="navbar-nav ml-auto">
   	<a href="#" class="nav-item nav-link">Halo {{ request.user.username }}</a>
  	<a href="{% url 'Story8:logout' %}" class="nav-item nav-link">Logout</a>
  </div>
  {% else %}
  <div class="navbar-nav ml-auto">
   	<a href="{% url 'Story8:register' %}" class="nav-item nav-link">Register</a>
  	<a href="{% url 'Story8:login' %}" class="nav-item nav-link">Login</a>
  </div>
  {% endif %}

</nav>

<br> 

<div class="container">
	<table class="table" id="list-buku">
	</table>
</div>

</body>


<script type="text/javascript">
	$("#keyword").keyup( function(item){
		var masukan = $("#keyword").val();
		console.log(masukan);
		$.ajax({
			url: '/story8/data?q=' + masukan, 
			success: function(data) {
				var judul = '<thead class="thead-dark"><tr><th>Judul</th><th>Penulis</th><th>Deskripsi</th><th>Sampul Buku</th></tr></thead>'
				var array_items = data.items;
				console.log(array_items);
				$("#list-buku").empty();
				$("#list-buku").append(judul);
				for (i = 0; i < array_items.length; i++) {
					var title = array_items[i].volumeInfo.title;
					var author = array_items[i].volumeInfo.authors;
					var desc = array_items[i].volumeInfo.description;
					var pict = array_items[i].volumeInfo.imageLinks.smallThumbnail;
					$("#list-buku").append("{% if user.is_authenticated %} <tr class='table-light'><td>" + title + "</td><td>" + author + "</td><td>" + desc + "</td><td><img src=" + pict + "></td></tr> {% else %} <tr class='table-light'><td>" + title + "</td><td>" + author + "</td><td> Please login to see </td><td>Please login to see</td></tr> {% endif %} ")
				}
			}
		});
	});
</script>

</html>